//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.framework.command;

import com.nexirius.framework.FWLog;

/**
 * This type is based on AbstractCommand and can be used for test purposes
 *
 * @author Marcel Baumann
 * @version Date        Chng.Rq.   Author    Changes/Enhancements
 *          1999.01.04             MB       Created
 */
public class TestCommand extends AbstractCommand {



    /**
     * Construct a test command
     *
     * @author Marcel Baumann
     */
    public TestCommand() {
        super();
    }


    /**
     * DefaultCommand constructor comment.
     *
     * @param commandName The name of the command
     */
    public TestCommand(String commandName) {
        super(commandName);
    }


    /**
     * Write an informative string to FWLog.log to indicate that the command
     * was executed.
     *
     * @author Marcel Baumann
     */
    @Override
    public boolean doAction() {
        FWLog.log("Action was performed for command " + getCommandName());
        return(true);
    }
}
