//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.framework.dataeditor;

import com.nexirius.framework.datamodel.DataModel;
import com.nexirius.framework.datamodel.DataModelCommand;
import com.nexirius.framework.datamodel.DataModelCommandVector;
import com.nexirius.framework.datamodel.PopupModel;
import com.nexirius.framework.dataviewer.DataViewer;
import com.nexirius.framework.dataviewer.ViewerFactory;
import com.nexirius.framework.swing.SwingViewer;

import javax.swing.*;
import java.awt.*;

/**
 * This class creates the content pane of a popup dialog window.
 *
 * @author Marcel Baumann
 */
public class PopupSwingViewer implements SwingViewer {



    PopupModel popupModel;
    JPanel panel;

    public JComponent createJComponent(ViewerFactory factory) {
        JPanel buttonPanel = new JPanel(new GridBagLayout());
        JComponent button = null;
        DataModelCommand command;
        DataViewer buttonViewer;
        DataModelCommandVector commandVector = popupModel.getMethods();
        GridBagConstraints buttonConstr = new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 2, 0, 2), 0, 0);

        if (commandVector != null) {

            for (command = commandVector.firstItem(); command != null; command = commandVector.nextItem()) {
                try {
                    buttonViewer = factory.createDefaultEditor(command);
                    button = buttonViewer.getJComponent();
                    buttonPanel.add(button, buttonConstr);
                    ++buttonConstr.gridx;
                } catch (Exception e) {
                    throw new RuntimeException(e);
                }
            }
        }

        return buttonPanel;
    }

    /**
     * return true
     */
    public boolean isEditor() {
        return true;
    }

    public void setDataModel(DataModel model) {
        this.popupModel = (PopupModel) model;
    }

    public DataModel getDataModel() {
        return popupModel;
    }

}
