package com.nexirius.framework.dataeditor;

import com.nexirius.framework.datamodel.BooleanModel;
import com.nexirius.framework.datamodel.DataModelEvent;
import com.nexirius.framework.datamodel.ModelFlag;
import com.nexirius.framework.dataviewer.DataViewer;
import com.nexirius.framework.swing.CFJToggleButton;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class ToggleButtonEditor extends DataViewer {
    public static final String editorName = "ToggleButton";

    public ToggleButtonEditor(BooleanModel model) {
        super(model);
    }

    public boolean isEditor() {
        return true;
    }

    public BooleanModel getModel() {
        return (BooleanModel)getDataModel();
    }

    public void create() {
        CFJToggleButton toggleButton = new CFJToggleButton(factory.getClientResource(), getDataModel().getFieldName());

        setJComponent(toggleButton);

        toggleButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                boolean b = ((JToggleButton) getJComponent()).isSelected();
                if (getModel().getBoolean() != b) {
                    getModel().setBoolean(b);
                    getModel().fireEditEvent(getModel(), DataModelEvent.VALUE_EDIT);
                }
            }
        });
        update();
    }

    public void update() {
        updateUI();
    }

    /**
     * this method is called when the boolean model has changed
     */
    public void updateUI() {
        if (isCreated()) {
            super.updateUI();

            ((JToggleButton)getJComponent()).setSelected(((BooleanModel)getModel()).getBoolean());

            if (getModel().isGray() || getModel().getFlag(ModelFlag.NOT_EDITABLE)) {
                getToggleButton().setEnabled(false);
            } else {
                getToggleButton().setEnabled(true);
            }
        }
    }

    private JToggleButton getToggleButton() {
        return (JToggleButton) getJComponent();
    }

    public String getViewerName() {
        return editorName;
    }
}
