package com.nexirius.framework.datamodel.json.format;

import com.nexirius.framework.datamodel.DataModel;
import com.nexirius.framework.datamodel.ModelFlag;
import com.nexirius.framework.datamodel.StringModel;
import com.nexirius.framework.datamodel.SimpleArrayModel;
import com.nexirius.framework.datamodel.json.DefaultJsonFormatMap;
import com.nexirius.framework.datamodel.json.IJsonFormat;
import com.nexirius.framework.datamodel.json.JsonParseException;
import com.nexirius.util.TextToken;

import java.io.IOException;
import java.io.OutputStream;
import java.io.PushbackInputStream;

public class SimpleArrayJsonFormat implements IJsonFormat {
    public void parseJson(PushbackInputStream in, DataModel target) throws Exception, JsonParseException {
        SimpleArrayModel simpleArrayModel = (SimpleArrayModel)target;
        TextToken token = TextToken.nextToken(in);

        if (token.isString()) {
            simpleArrayModel.dropData(token.getString());
        } else {
            throw new JsonParseException(token, "SimpleArrayModel", "");
        }
    }

    public void writeJson(DataModel source, OutputStream out) throws Exception {
        SimpleArrayModel simpleArrayModel = (SimpleArrayModel)source;

        out.write(TextToken.quoteString(simpleArrayModel.dragData()).getBytes(DefaultJsonFormatMap.CHARSET));
    }
}