//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.framework.datamodel.parser;

import com.nexirius.framework.datamodel.ComboBoxModel;
import com.nexirius.framework.datamodel.DataModel;
import com.nexirius.framework.datamodel.SimpleArrayModel;

import java.util.HashSet;
import java.util.Iterator;

/**
 * A class which represents a DataModel enum
 *
 * @author Marcel Baumann
 */
public class DataModelTypeEnum extends DataModelType {



    HashSet values;

    public DataModelTypeEnum(String name) {
        super(name);
        values = new HashSet();
    }

    public DataModel newInstance(DataModelClasses classes)
            throws ParserException {
        return new ComboBoxModel(0, new SimpleArrayModel(values.toArray()), getName());
    }

    public void addValue(String v)
            throws Exception {
        values.add(v);
    }

    public boolean hasValue(String name) {
        return values.contains(name);
    }

    public void appendDTD(StringBuffer sb) {
    }

    public Iterator getIterator() {
        return values.iterator();
    }
}
