package com.nexirius.framework.datamodel.persistence.generic;

import com.nexirius.framework.datamodel.StringModel;
import com.nexirius.util.StringVector;

import java.util.Enumeration;
import java.util.Hashtable;

public class DataModelSearchAttributesTable {
    Hashtable table = new Hashtable();

    public void add(String databaseTableName, String dataModelClassName, String[] searchableFields) {
        add(databaseTableName, dataModelClassName, new StringVector(searchableFields));
    }

    public void add(String databaseTableName, String dataModelClassName, StringVector searchableFields) {
        add(new DataModelSearchAttributes(databaseTableName, dataModelClassName, searchableFields));
    }

    public void add(DataModelSearchAttributes searchAttributes) {
        table.put(searchAttributes.getDataModelClassName(), searchAttributes);
    }

    public DataModelSearchAttributes getSearchAttributes(String dataModelClassName) {
        return (DataModelSearchAttributes) table.get(dataModelClassName);
    }

    public StringVector getDataModelClassNames() {
        StringVector ret = new StringVector();
        Enumeration en = table.keys();

        while (en.hasMoreElements()) {
            String dataModelClassName = (String) en.nextElement();

            ret.sortInsert(dataModelClassName);
        }

        return ret;
    }
}
