package com.nexirius.framework.datamodel.persistence.generic;

import com.nexirius.framework.datamodel.DataModel;
import com.nexirius.framework.datamodel.ArrayModel;
import com.nexirius.framework.datamodel.IDataModelFilter;

import java.sql.SQLException;
import java.io.InputStream;
import java.io.File;

public interface IGenericDatabase {
    public IGenericNamespace getGenericNamespace();
    public void create(DataModel model) throws Exception;
    public boolean read(DataModel model, String instanceName) throws Exception;
	public String readAsString(String instanceName) throws Exception;
    public void update(DataModel model) throws Exception;
    public void delete(String instanceName) throws Exception;
    public int search(ArrayModel result, DataModel template, StringBuffer whereClause) throws Exception;
    public int search(ArrayModel result, DataModel template, String orderBy, WhereClause... whereClause) throws Exception;
    public int load(ArrayModel result, DataModel template) throws Exception;
    public void createReference(DataModel owner, DataModel reference) throws Exception;
    public int load(ArrayModel result, DataModel template, IDataModelFilter filter) throws Exception;
    public String putBlob(File file, String mimeType, String key) throws Exception;
    public String putBlob(InputStream in, String mimeType, String key) throws Exception;
    public InputStream getBlob(String key) throws Exception;
    public String testConnection();
}
