package com.nexirius.framework.datamodel.persistence.generic;

import java.util.Collection;
import java.util.Iterator;

public class WhereClause {
    public String attribute;
    public Operator operator; // one of = > < >= <=
    public String value;

    public WhereClause(String attribute, Operator operator, String value) {
        this.attribute = attribute;
        this.operator = operator;
        this.value = value;
    }

    public static void appendOr(StringBuffer sb) {
        if (sb.length() > 0 && sb.charAt(sb.length() - 1) != '(') {
            sb.append(" OR ");
        }
    }

    public static void appendAnd(StringBuffer sb) {
        if (sb.length() > 0 && sb.charAt(sb.length() - 1) != '(') {
            sb.append(" AND ");
        }
    }

    public static void appendIn(StringBuffer whereClause, Collection keys) {
        whereClause.append(" IN (");

        boolean first = true;

        for (Iterator iterator = keys.iterator(); iterator.hasNext();) {
            Object key = iterator.next();

            if (first) {
                first = false;
            } else {
                whereClause.append(',');
            }

            whereClause.append(key.toString());
        }

        whereClause.append(')');
    }
}
