package com.nexirius.framework.datamodel.xml;

import com.nexirius.framework.datamodel.DataModel;
import com.nexirius.framework.datamodel.DataModelEnumeration;
import com.nexirius.framework.datamodel.DataModelVector;

import java.io.IOException;
import java.io.OutputStream;

public class StructModelXmlGenerator implements IXmlGenerator {
    public static final String STRUCT_MODEL = "StructModel";

    public void generateXml(DataModelXmlGenerator generator, OutputStream out, DataModel model) throws IOException {
        DataModelVector children = model.getChildren();
        DataModelEnumeration en = children.getEnumeration();

        generator.startTag(out, STRUCT_MODEL, model.getFieldName());
        generator.newLine(out);
        generator.incrementIndent();
        while(en.hasMore()) {
            DataModel dataModel = en.next();
            generator.indent(out);
            generator.generateXml(out, dataModel);
            generator.newLine(out);
        }
        generator.decrementIndent();
        generator.indent(out);
        generator.endTag(out, STRUCT_MODEL);
    }
}
