package com.nexirius.framework.dataviewer;

import com.nexirius.framework.datamodel.DataModel;
import com.nexirius.framework.datamodel.DataModelAdaptor;
import com.nexirius.framework.datamodel.DataModelEvent;
import com.nexirius.framework.datamodel.InstanceNameComboBoxModel;

import javax.swing.*;
import javax.swing.event.ListDataEvent;
import javax.swing.event.ListDataListener;
import java.util.Hashtable;

public class ArrayModelInstanceNameComboBoxModel implements ComboBoxModel {
    private InstanceNameComboBoxModel instanceNameComboBox;
    private Hashtable listenerInstances = new Hashtable();

    public ArrayModelInstanceNameComboBoxModel(InstanceNameComboBoxModel instanceNameComboBox) {
        this.instanceNameComboBox = instanceNameComboBox;
    }

    public Object getSelectedItem() {
        return instanceNameComboBox.getSelectedDataModel();
    }

    public void setSelectedItem(Object anItem) {
        if (anItem == null) {
            instanceNameComboBox.setText(null);
        } else {
            instanceNameComboBox.setText(((DataModel)anItem).getInstanceName());
        }
    }

    public int getSize() {
        return instanceNameComboBox.getArrayModel().getSize() + 1;
    }

    public Object getElementAt(int index) {
        if (index == 0) {
            return null;
        }
        return instanceNameComboBox.getArrayModel().getDataModel(index - 1);
    }

    public void addListDataListener(ListDataListener l) {
        ListDataListenerModelListener listener = new ListDataListenerModelListener(l);
        listenerInstances.put(l, listener);
        instanceNameComboBox.getArrayModel().addSoftDataModelListener(listener);
    }

    public void removeListDataListener(ListDataListener l) {
        ListDataListenerModelListener listener = (ListDataListenerModelListener) listenerInstances.get(l);
        if(listener != null) {
            instanceNameComboBox.getArrayModel().removeDataModelListener(listener);
        }
    }

    public class ListDataListenerModelListener extends DataModelAdaptor {
        private ListDataListener listener;

        public ListDataListenerModelListener(ListDataListener listener) {
            this.listener = listener;
        }

        public void dataModelChangeValue(DataModelEvent event) {
            listener.contentsChanged(new ListDataEvent(instanceNameComboBox.getArrayModel(), ListDataEvent.CONTENTS_CHANGED, 0, getSize() - 1));
        }
    }
}
