//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.framework.dataviewer;

import com.nexirius.framework.swing.SwingViewer;
import com.nexirius.framework.datamodel.DataModel;
import com.nexirius.framework.datamodel.DataModelAdaptor;
import com.nexirius.framework.datamodel.DataModelEvent;

import javax.swing.*;

public class CaptionViewer implements SwingViewer {

    protected DataModel model;
    protected JLabel jLabel;
    protected UpdateListener listener;

    public JComponent createJComponent(ViewerFactory factory) {
        jLabel = new JLabel(model.getCaption());
        return jLabel;
    }

    public boolean isEditor() {
        return false;
    }

    public void setDataModel(DataModel model) {
        this.model = model;
        listener = new UpdateListener();
        model.addSoftDataModelListener(listener);
    }

    public DataModel getDataModel() {
        return model;
    }

    public void update() {
        jLabel.setText(model.getCaption()); 
    }

    public class UpdateListener extends DataModelAdaptor {
        public void dataModelChangeValue(DataModelEvent event) {
            update();
        }
    }
}
