package com.nexirius.framework.dataviewer;

import com.nexirius.framework.swing.SwingViewer;
import com.nexirius.framework.datamodel.*;

import javax.swing.*;

public class ProgressAdaptorViewer extends JPanel implements SwingViewer {
    private ProgressAdaptorModel progressAdaptorModel;
    private ViewerFactory factory;

    public JComponent createJComponent(ViewerFactory factory) {
        setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
        this.factory = factory;
        updateGui();

        progressAdaptorModel.addDataModelListener(new StructureChangedListener());

        return this;
    }

    private void updateGui() {
        removeAll();

        try {
            DataModelContainer doubles = (DataModelContainer) progressAdaptorModel.getChild(ProgressAdaptorModel.FIELD_progressBars);
            DataModelEnumeration en = doubles.getEnumeration();

            while(en.hasMore()) {
                add(factory.createViewer(new ProgressViewerCreator(), en.next()).getJComponent());
            }
        } catch (Exception e) {
            throw new RuntimeException(e);  //To change body of catch statement use File | Settings | File Templates.
        }
    }

    public boolean isEditor() {
        return false;
    }

    public void setDataModel(DataModel model) {
        progressAdaptorModel = (ProgressAdaptorModel)model;
    }

    public DataModel getDataModel() {
        return progressAdaptorModel;
    }

    class StructureChangedListener extends DataModelAdaptor {
        public void dataModelChangeStructure(DataModelEvent event) {
            updateGui();
        }
    }
}
