//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.framework.dataviewer;

import com.nexirius.framework.datamodel.SimpleArrayModel;

import javax.swing.*;
import java.awt.*;

/**
 * This viewer is designed to show a list of Objects in a Swing JList
 *
 * @author Marcel Baumann
 */
public class SimpleArrayViewer extends DataViewer {



    public static final String s_viewername = "SimpleArrayViewer";

    JList list = null;

    /**
     * Creates a list viewer based on an array of any simple type
     */
    public SimpleArrayViewer(SimpleArrayModel model) {
        super(model);
    }

    /**
     * Returns the assotiated data model
     */
    public SimpleArrayModel getModel() {
        return (SimpleArrayModel) getDataModel();
    }

    /**
     * Creates the JList
     */
    public void create() {
        list = new JList(getModel().getListModel());
        setJComponent(new JScrollPane(this.list));
        getJComponent().setPreferredSize(new Dimension(300, 200));
    }

    /**
     * No specific implementation
     */
    public void update() {
    }

    /**
     * Only for debugging
     */
    public String getViewerName() {
        return s_viewername;
    }
}
