//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.framework.htmlview;

public interface HTMLCommand {
    /**
     * If true then the request parameters are stored in the actual DataModel, which is held in the current state.
     * @return true to map request variables to the actual DataModel in the current state
     */
    public boolean requiresMapping();

    /**
     * Do whatever needs to be done when the state transition takes place, which holds this command.
     * @param sessionVariable
     * @return true if command was successul and state transition should take place (if false then the actual state is not left)
     * @throws Exception The exception is caught by JnexServlet and triggers the HTMLApplication.handleException method
     */
    public boolean execute(HTMLSessionVariable sessionVariable) throws Exception;

    /**
     * return true if command sends the response back itself
     */
    public boolean handlesResponse();
}
