//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.framework.htmlview.function;

import com.nexirius.framework.htmlview.HTMLParser;
import com.nexirius.framework.htmlview.HTMLResolver;
import com.nexirius.framework.htmlview.HTMLSessionVariable;

/**
 * This class handles the $!button("event") function which is translated into
 * &lt;INPUT type='submit' name='button@event@state' value='$!translate("event")/&gt;
 * <br>
 * <INPUT type='submit' name='button@event@state' value='$!translate("event.buttonText")'/>
 */
public class ButtonHTMLFunction extends DefaultHTMLFunction {

    public String getFunctionName() {
        return "button";
    }

    public String getEvent() {
        return getArgument(0);
    }

    public void translate(HTMLSessionVariable sessionVariable, HTMLParser parser)
            throws Exception {
        String event = getEvent();

        if (event == null) {

            throw new Exception("button function needs at least one parameter (event)");
        }

        StringBuffer buf = new StringBuffer();

        buf.append("<INPUT type='submit' name='");
        buf.append(HTMLFunction.PARAMETER_BUTTON);
        buf.append(event);
        buf.append("@$(STATE)' value='$!translate(\"");
        buf.append(event);
        buf.append(".buttonText\")' />");

        parser.getOut().write(buf.toString().getBytes(HTMLResolver.CHARSET));
    }
}
