//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.framework.htmlview.function;

import com.nexirius.framework.htmlview.HTMLResolver;
import com.nexirius.framework.htmlview.HTMLSessionVariable;
import com.nexirius.framework.htmlview.HTMLParser;
import com.nexirius.framework.htmlview.VariableStore;

/**
 * creates a form start tag (default method is get user parameter post to change method)
 * <PRE>
 * $!formStart()
 * &lt;form action='$(REQUEST_URL)' method='get'&gt;
 * $!formStart(post)
 * &lt;form action='$(REQUEST_URL)' method='post'&gt;
 * </PRE>
 */
public class FormStartHTMLFunction implements HTMLFunction {

    public String getFunctionName() {
        return "formStart";
    }

    public void translate(HTMLSessionVariable sessionVariable, HTMLParser parser, String[] arguments) throws Exception {
        String method = "get";
        if (arguments.length > 0) {
            method = arguments[0];
        }
        parser.getOut().write("<form action='$!encodeURL(\"$(".getBytes(HTMLResolver.CHARSET));
        parser.getOut().write(VariableStore.REQUEST_URL.getBytes(HTMLResolver.CHARSET));
        parser.getOut().write(")\")' method='".getBytes(HTMLResolver.CHARSET));
        parser.getOut().write(method.getBytes(HTMLResolver.CHARSET));
        parser.getOut().write("'>".getBytes(HTMLResolver.CHARSET));
    }
}
