package com.nexirius.framework.jdbc;

import com.nexirius.framework.datamodel.DataModel;

import java.util.Random;
import java.util.Date;
import java.text.SimpleDateFormat;

public class RandomPrimaryKeyGenerator implements IPrimaryKeyGenerator {
    private static final Random RANDOM = new Random(new Date().getTime());
    public static final SimpleDateFormat SIMPLE_DATE_FORMAT = new SimpleDateFormat("yyMMddkkmm00000000");

    public String createPrimaryKey(DataModel model) {
        long r = RANDOM.nextLong();

        r = Math.abs(r);
        String d = SIMPLE_DATE_FORMAT.format(new Date());
        r = r % 100000000L + Long.parseLong(d);

        return Long.toString(r);
    }

    public static void main(String[] argv) {
        String primaryKey = new RandomPrimaryKeyGenerator().createPrimaryKey(null);

        System.out.println("primaryKey = " + primaryKey);
        System.out.println("maxlong =    " + Long.MAX_VALUE);
        System.out.println("maxPrimKey = " + 999999999900000000L);
    }
}
