//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.framework.layout;

import com.nexirius.framework.dataviewer.SimpleViewerCreator;
import com.nexirius.framework.dataviewer.ViewerCreator;

import java.awt.*;

public class AssistantFormLayout extends StructureLayoutItem {




    String formFieldName;

    public AssistantFormLayout() {
        init(null, null);
    }

    public AssistantFormLayout(String name, String formFieldName, ViewerCreator formViewerCreator, DefaultLayoutItem formLayout) {
        modelFieldName = name;
        this.formFieldName = formFieldName;
        init(formViewerCreator, formLayout);
    }

    private void init(ViewerCreator formViewerCreator, DefaultLayoutItem formLayout) {
        GridBagConstraints title = new GridBagConstraints();
        GridBagConstraints form = new GridBagConstraints();
        GridBagConstraints prev = new GridBagConstraints();
        GridBagConstraints next = new GridBagConstraints();
        MultiplePropertyEntry titleProps = new MultiplePropertyEntry();

        titleProps.append(new SinglePropertyEntry("Font", "Arial-BOLD-24"));
        titleProps.append(new SinglePropertyEntry("Foreground", "white"));
        titleProps.append(new SinglePropertyEntry("Background", "blue"));
        titleProps.append(new SinglePropertyEntry("Alignment", "0"));

        title.fill = GridBagConstraints.HORIZONTAL;
        title.gridwidth = 2;
        title.gridheight = 1;

        form.fill = GridBagConstraints.BOTH;
        form.weighty = 1.0;
        form.gridwidth = 2;
        form.gridheight = 1;
        form.insets = new Insets(10, 3, 10, 3);

        prev.anchor = GridBagConstraints.WEST;
        prev.weightx = 1.0;
        prev.gridwidth = 1;
        prev.gridheight = 1;
        prev.insets = new Insets(3, 10, 3, 10);

        next.anchor = GridBagConstraints.EAST;
        next.weightx = 1.0;
        next.gridwidth = 1;
        next.gridheight = 1;
        next.insets = new Insets(3, 10, 3, 10);

        String fieldName = "Form";

        if (formFieldName != null) {
            fieldName = "Form;" + formFieldName;
        }

        append(new GridBagLayoutItem("Title;titleText", 0, 0, -1, -1, new SimpleViewerCreator(), null, false, "Title", titleProps, title));
        append(new GridBagLayoutItem(fieldName, 0, 1, -1, -1, formViewerCreator, formLayout, false, "Form", null, form));
        append(new GridBagLayoutItem("assistantStepPrev", 0, 2, -1, -1, null, null, false, "assistantStepPrev", null, prev));
        append(new GridBagLayoutItem("assistantStepNext", 1, 2, -1, -1, null, null, false, "assistantStepNext", null, next));
    }
}

