//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.framework.layout;

import java.awt.*;

/**
 * This class defines the layout of a static label in a gridbag layout container
 *
 * @author Marcel Baumann
 */
public class GridBagLabelLayoutItem extends LabelLayoutItem {



    /**
     * @param labelResourceId The associated resource ID which is associated with the created label
     * @param x               the gridx position of the component
     * @param y               the gridy position of the component
     * @param w               the gridwidth of the component
     * @param h               the gridheight of the component
     * @param prop            Additional properties for the label
     * @param constraints     the GridBagConstraints
     */
    public GridBagLabelLayoutItem(String labelResourceId, int x, int y, int w, int h, PropertyEntry prop, GridBagConstraints constraints) {
        super(labelResourceId, 0, 0, 0, 0, prop);

        if (constraints != null) {
            constraints = (GridBagConstraints) constraints.clone();

            if (x >= 0) {
                constraints.gridx = x;
            }

            if (y >= 0) {
                constraints.gridy = y;
            }

            if (w >= 0) {
                constraints.gridwidth = w;
            }

            if (h >= 0) {
                constraints.gridheight = h;
            }

            setGridBagConstraints(constraints);
        }
    }
}
