//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.framework.onlinehelp;

import java.awt.*;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

//import java.lang.ref.WeakReference;


/**
 * A singleton class which handles online help events
 *
 * @author Marcel Baumann
 *         <p/>
 *         Date        Author           Changes/Enhancements
 *         2000-3-28  Marcel Baumann     Created
 */
public class OnlineHelp {



    private static OnlineHelp instance;

//	Hashtable helpComponents = new Hashtable();
    OnlineHelpManager manager = null;

    private OnlineHelp(OnlineHelpManager m) {
        manager = m;
    }

    public static void init(OnlineHelpManager m) {
        instance = new OnlineHelp(m);
    }

    public static void set(Component component, String resourceKey) {
        if (instance == null) {

            return;
        }

        String text = getInstance().manager.getHelpString(resourceKey);

        if (text != null) {
            component.addKeyListener(new MyKeyListener(text));
        }

//		if (text != null) {
//			getInstance().set(new HelpComponent(component, text));
//		}
    }

/*
	private void set(HelpComponent helpComponent)
	{
		HelpComponent old = (HelpComponent)helpComponents.get(helpComponent.getComponent());

		if (old != null) {
			old.remove();
		}

		helpComponent.init();
		helpComponents.put(helpComponent.getComponent(), helpComponent);
	}
*/
    public static OnlineHelp getInstance() {
        if (instance == null) {
            throw new RuntimeException("OnlineHelp.init() was not called");
        }

        return instance;
    }

    public static String getHelpString(String resourceKey) {
        return getInstance().manager.getHelpString(resourceKey);
    }

    public static void help(String text) {
        getInstance().manager.help(text);
    }
}

/*
class HelpComponent {
	WeakReference component;
	String text;
	KeyListener listener;

	HelpComponent(Component c, String t)
	{
		component = new WeakReference(c);
		text = t;
	}

	Component getComponent()
	{
		return (Component)component.get();
	}

	public void init()
	{
		listener = new MyKeyListener();
		Component c = getComponent();

		if (c != null) {
			c.addKeyListener(listener);
		}
	}

	public void remove()
	{
		Component c = getComponent();

		if (c != null) {
			c.removeKeyListener(listener);
		}
	}
}
*/

class MyKeyListener implements KeyListener {
    String text;

    MyKeyListener(String text) {
        this.text = text;
    }

    public void keyTyped(KeyEvent e) {
    }

    public void keyPressed(KeyEvent e) {
        if (e.getKeyCode() == KeyEvent.VK_F1) {
            System.out.println("KeyListener:keyPressed" + text);
            OnlineHelp.help(text);
        }
    }

    public void keyReleased(KeyEvent e) {
    }
}


