//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.framework.remote;

import com.nexirius.framework.datamodel.DataModelAdaptor;
import com.nexirius.framework.datamodel.DataModelEvent;
import com.nexirius.tcp.ClientImpl;

import java.io.InputStream;
import java.io.OutputStream;

class RemoteDataModelListener extends DataModelAdaptor {
    OutputStream out;
    InputStream in;

    public RemoteDataModelListener(OutputStream out, InputStream in) {
        this.out = out;
        this.in = in;
    }

    public void dataModelChangeValue(DataModelEvent event) {
        try {
            System.out.println(event.toString());

            DataModelUpdateEvent e = new DataModelUpdateEvent(event);

            out.write(DataModelRemoteEvent.COMMAND_UPDATE.getBytes());
            e.writeDataTo(out);
            out.write(ClientImpl.END_OF_MSG_CHAR);

            answer(ClientImpl.readMessageFromStream(in));
        } catch (Exception ex) {
            throw new RuntimeException(ex);
        }
    }

    public void dataModelEdit(DataModelEvent event) {
        System.out.println(event.toString());

        if (event.getId() != DataModelEvent.CALL_METHOD) {
            return;
        }

        try {
            DataModelMethodEvent e = new DataModelMethodEvent(event);

            out.write(DataModelRemoteEvent.COMMAND_METHOD.getBytes());
            e.writeDataTo(out);
            out.write(ClientImpl.END_OF_MSG_CHAR);

            answer(ClientImpl.readMessageFromStream(in));
        } catch (Exception ex) {
            throw new RuntimeException(ex);
        }
    }

    public void answer(String answ) {

    }
}


