//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.framework.remote;

import com.nexirius.framework.datamodel.*;

/**
 * @author Marcel Baumann
 */
public class TestModel extends StructModel implements RemoteDataModel {



    ArrayModel arr;
    StructModel struct;
    boolean onServer = false;

    public TestModel(String name, boolean onServer) {
        super(name);

        initMembers();
        this.onServer = onServer;
    }

    private void initMembers() {
        append(new IntModel(0, "int"));
        append(new StringModel("", "string"));
        append(new DateModel(new java.util.Date(), "date"));
        struct = new StructModel("struct");
        struct.append(new StringModel("", "substring1"));
        struct.append(new StringModel("", "substring2"));
        append(struct);
        arr = new ArrayModel(struct.getFullFieldName());

        DefaultDataModelCommand add = new DefaultDataModelCommand("addMethod");
        append(arr);
        appendMethod(add);
    }

    public void addMethod() {
        if (onServer()) {
            arr.append(arr.createDefaultChild());
        } else {
            DataModelEvent event = new DataModelEvent(this, DataModelEvent.CALL_METHOD, true);

            event.setData("addMethod");
            propagateChildEvent(event);
        }
    }

    public static DataModel createStruct() {
        StructModel s = new StructModel("");

        s.append(new StringModel("", "substring1"));
        s.append(new StringModel("", "substring2"));

        return s;
    }

    public DataModel getDataModel() {
        return this;
    }

    public int getID() {
        return 1;
    }

    public int getVersion() {
        return 1;
    }

    public boolean onServer() {
        return onServer;
    }

/*	class StructMemberCreator implements DataModelCreator
	{
		public DataModel createDataModel()
		{
			return createStruct();
		}
	}

*/
}

