package com.nexirius.framework.rest.example.parameter;

import com.nexirius.framework.datamodel.StringModel;
import com.nexirius.framework.datamodel.DataModel;
import com.nexirius.framework.datamodel.StructModel;

public class ReadParameterModel extends StructModel {
    private StringModel key;
    private StringModel resultType;

    public ReadParameterModel() {
        super("ReadParameter");
        init("", "");
    }

    public ReadParameterModel(String key, String resultType) {
        super("ReadParameter");
        init(key, resultType);
    }

    private void init(String key, String resultType) {
        append(this.key = new StringModel(key, "key"));
        append(this.resultType = new StringModel(resultType, "resultType"));
    }

    public String getKey() {
        String ret = key.getText();
        return ret.length() == 0 ? null : ret;
    }

    public DataModel getResultTemplate() throws Exception {
        return (DataModel)ClassLoader.getSystemClassLoader().loadClass(resultType.getText()).newInstance();
    }

}
