package com.nexirius.framework.rest.example.parameter;

import com.nexirius.framework.datamodel.StructModel;
import com.nexirius.framework.datamodel.StringModel;
import com.nexirius.framework.datamodel.DataModel;

public class SearchParameterModel extends StructModel {
    private StringModel whereClause;
    private StringModel resultType;

    public SearchParameterModel() {
        super("SearchParameter");
        init("", "");
    }

    public SearchParameterModel(String whereClause, String resultType) {
        super("SearchParameter");
        init(whereClause, resultType);
    }

    private void init(String whereClause, String resultType) {
        append(this.whereClause = new StringModel(whereClause, "whereClause"));
        append(this.resultType = new StringModel(resultType, "resultType"));
    }

    public String getWhereClause() {
        String ret = whereClause.getText();
        return ret.length() == 0 ? null : ret;
    }

    public DataModel getResultTemplate() throws Exception {
        return (DataModel)ClassLoader.getSystemClassLoader().loadClass(resultType.getText()).newInstance();
    }
}
