package com.nexirius.framework.rest.example.parameter;

import com.nexirius.framework.datamodel.DataModel;
import com.nexirius.framework.datamodel.StringModel;
import com.nexirius.framework.datamodel.StructModel;
import com.nexirius.framework.datamodel.json.DefaultJsonFormatMap;

public class UpdateParameterModel extends StructModel {
    private StringModel parameterType;
    private StringModel json;

    public UpdateParameterModel() {
        super("UpdateParameter");
        init("", "");
    }

    public UpdateParameterModel(DataModel model) throws Exception {
        super("UpdateParameter");
        init(model.getClass().getName(), DefaultJsonFormatMap.createJson(model));
    }

    private void init(String parameterType, String json) {
        append(this.parameterType = new StringModel(parameterType, "parameterType"));
        append(this.json = new StringModel(json, "json"));
    }

    public DataModel getDataModel() throws Exception {
        DataModel dataModel = (DataModel) ClassLoader.getSystemClassLoader().loadClass(parameterType.getText()).newInstance();

        DefaultJsonFormatMap.readDataModel(dataModel, json.getText());

        return dataModel;
    }
}