//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.framework.textselector;

import java.util.Enumeration;
import java.util.Hashtable;

/**
 * this class is implemented as a singlton and is used to access TextSelectors which are registered
 * with unique names in a generateFileInfo table
 */
public class TextSelectorManager {



    private static TextSelectorManager instance = null;

    Hashtable list = new Hashtable();

    private TextSelectorManager() {
    }

    public static TextSelectorManager getInstance() {
        if (instance == null) {
            instance = new TextSelectorManager();
        }

        return instance;
    }

    public void addTextSelector(TextSelector t) {
        list.put(t.getName(), t);
    }

    public TextSelector getTextSelector(String name) {
        TextSelector ret = (TextSelector) list.get(name);

        if (ret == null) {
            throw new RuntimeException("No such TextSelector: " + name);
        }

        return ret;
    }

    public Enumeration getAllTextSelectorNames() {
        return list.keys();
    }
}

