//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.framework.trend;

public class DoubleRange {



    public static double log10 = Math.log(10);
    double value;
    double width;

    public DoubleRange(double from, double w) {
        value = from;
        width = w;
    }

    public void extend(double v) {
        if (v < min()) {
            width = max() - v;
            value = v;
        } else if (v > max()) {
            width = v - value;
        }
    }

    public double min() {
        return value;
    }

    public double max() {
        return value + width;
    }

    public double width() {
        return width;
    }

    public double getRelativeLocation(double position) {
        if (width == 0) {

            return 0;
        }

        return (position - value) / width;
    }

    public double base() {
        int digits = (int) (Math.log(width) / log10);

        return Math.pow(10, digits);
    }

    public void round() {
        width = (width <= 0.0 ? width = 1.0 : width);

        double base = base();

        value = Math.floor(value / base) * base;
        double max = Math.ceil(max() / base) * base;

        if (max == value) {
            max += base;
        }

        width = max - value;
    }

    public boolean contains(double v) {
        if (v >= value && v <= max()) {

            return true;
        }

        return false;
    }
}
