//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.framework.trend;

import java.awt.*;

public class TrendGrid {



    boolean xAchsis = true;

    public LabelPositionVector getPositions(Rectangle rect) {
        return null;
    }

    public void paintGrid(Graphics g, Rectangle rect, LabelPositionVector v) {
        int x1;
        int x2;
        int y1;
        int y2;

        for (LabelPosition pos = v.first(); pos != null; pos = v.next()) {
            if (xAchsis) {
                x1 = pos.pos;
                x2 = x1;
                y1 = (int) rect.getY();
                y2 = (int) (rect.getY() + rect.getHeight());
            } else {
                x1 = (int) rect.getX();
                x2 = (int) (rect.getX() + rect.getWidth());
                y1 = pos.pos;
                y2 = y1;
            }
            g.drawLine(x1, y1, x2, y2);
        }
    }

    public void paintScale(Graphics g, Rectangle rect, LabelPositionVector v) {
        int x;
        int y;
        int yoff = (int) g.getFontMetrics().getAscent();

        for (LabelPosition pos = v.first(); pos != null; pos = v.next()) {
            if (xAchsis) {
                x = pos.pos;
                y = (int) rect.getY() + yoff;
            } else {
                x = (int) rect.getX();
                y = pos.pos;
            }
            g.drawString(pos.label, x, y);
        }
    }
}
