//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.print;



public class PrintTableDataAccessor {



    protected String columnNames[];
    protected PrintTableData data;

    public PrintTableDataAccessor(PrintTableData data, String columnNames[]) {
        this.data = data;
        this.columnNames = columnNames;
    }

    public String get(int zone, int col, int row, int pageIndex) {
        if (zone == PrintTable.DATA_ZONE) {

            return data.getData(columnNames[col], row, pageIndex);
        } else if (zone == PrintTable.HEADER_ZONE) {

            return data.getHeader(columnNames[col]);
        } else if (zone == PrintTable.FOOTER_ZONE) {

            return data.getFooter(columnNames[col]);
        }

        return null;
    }

    public String get(int zone, String col, int row, int pageIndex) {
        if (zone == PrintTable.DATA_ZONE) {

            return data.getData(col, row, pageIndex);
        } else if (zone == PrintTable.HEADER_ZONE) {

            return data.getHeader(col);
        } else if (zone == PrintTable.FOOTER_ZONE) {

            return data.getFooter(col);
        }

        return null;
    }

    public int getRowCount() {
        return data.getRowCount();
    }
}
