//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 *
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 *
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 *
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 *
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.tools.dirsync;

import com.nexirius.framework.datamodel.ComboBoxModel;
import com.nexirius.framework.datamodel.SimpleArrayModel;

public class DirSyncStatusModel extends ComboBoxModel {

    public static String[] STATUS_TAGS = new String[]{DirSyncStatus.STATUS_EQUAL.getName(), DirSyncStatus.STATUS_CREATE.getName(), DirSyncStatus.STATUS_CHANGE.getName(), DirSyncStatus.STATUS_REMOVE.getName()};
    public static final int STATUS_CREATE = DirSyncStatus.STATUS_CREATE.getCode();
    public static final int STATUS_CHANGE = DirSyncStatus.STATUS_CHANGE.getCode();
    public static final int STATUS_REMOVE = DirSyncStatus.STATUS_REMOVE.getCode();
    public static final String FIELD_NAME = "DirSyncStatus";

    public DirSyncStatusModel() {
        super(0, new SimpleArrayModel((Object[])STATUS_TAGS), FIELD_NAME);
    }

    public void setCreate() {
        setInt(STATUS_CREATE);
    }

    public void setChange() {
        setInt(STATUS_CHANGE);
    }

    public void setRemove() {
        setInt(STATUS_REMOVE);
    }

    public boolean isCreateStatus() {
        return getInt() == STATUS_CREATE;
    }

    public boolean isChangeStatus() {
        return getInt() == STATUS_CHANGE;
    }

    public boolean isRemoveStatus() {
        return getInt() == STATUS_REMOVE;
    }
}
