//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.tools.properties.model;

import com.nexirius.framework.datamodel.ArrayModel;

public class ExtensionArrayModel extends ArrayModel {

    public static ExtensionModel BUTTON_TEXT = new ExtensionModel("buttonText", "Button Label");
    public static ExtensionModel MNEMONIC = new ExtensionModel("mnemonic", "Button Mnemonic");
    public static ExtensionModel MENU = new ExtensionModel("menu", "Menu Text");
    public static ExtensionModel ICON = new ExtensionModel("icon", "Icon File Name");
    public static ExtensionModel MESSAGE = new ExtensionModel("message", "Message");

    public static final String FIELD_NAME = "ExtensionArray";

    public ExtensionArrayModel() {
        super(new ExtensionModel(), FIELD_NAME);
        init();
    }

    private void init() {
        append(BUTTON_TEXT);
        append(MNEMONIC);
        append(MENU);
        append(ICON);
        append(MESSAGE);
    }
}
