package com.nexirius.util;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.util.Enumeration;
import java.util.Properties;

public class PropertiesHelper {
    /**
     * read from file or URL
     * @param source file name or URL
     * @throws java.io.IOException
     */
    public static void loadSystemProperties(String source) throws IOException {
        File file = new File(source);
        InputStream in;

        if (file.exists()) {
            in = new FileInputStream(file);
        } else {
            in = new URL(source).openStream();
        }

        loadSystemProperties(in);
    }

    public static void loadSystemProperties(InputStream in) throws IOException {
        Properties properties = new Properties();
        properties.load(in);

        Enumeration<Object> en = properties.keys();

        while (en.hasMoreElements()) {
            String key = (String) en.nextElement();
            String value = properties.getProperty(key);

            System.setProperty(key, value);

            System.out.println("System Property " + key + " = " + value);
        }
    }
}
