//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.util;

public class TextFileException extends java.io.IOException {



    int m_err = 0;		// contains the id of the latest error

    public static final String error_strings[] = {
        "No error",
        "1: The file id contains no characters",
        "2: The file id is null",
        "3: Can't open a file which is still open",
        "4: File already exists",
        "5: File does not exist",
        "6: Can't open file for read",
        "7: Can't open a file with a different file id",
        "8: Can't read header",
        "9: The file is not open for read",
        "10: This is no TextFile (id string not found)",
        "11: Format corrupted (expected ':' not found)",
        "12: Format corrupted (expected \"file id\" not found)",
        "13: Can't read version flag",
        "14: Can't write header",
        "15: Can't write to a file which is not open for write",
    };

    public TextFileException(int err) {
        super(error_strings[err]);
        m_err = err;
    }

    /**
     * @returns the string representation of the error
     */
    public String getMessage() {
        return error_strings[getError()];
    }

    /**
     * @returns the error
     */
    public int getError() {
        return m_err;
    }
}
