//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.util.locale;

/**
 * This is the event multicaster class to support the com.nexirius.framework.LocaleListenerinterface.
 */
public class LocaleEventMulticaster
        extends java.awt.AWTEventMulticaster
        implements LocaleListener {




    /**
     * Constructor to support multicast events.
     *
     * @param a com.nexirius.framework.LocaleListener
     * @param b com.nexirius.framework.LocaleListener
     */
    protected LocaleEventMulticaster(LocaleListener a, LocaleListener b) {
        super(a, b);
    }

    /**
     * Add new listener to support multicast events.
     *
     * @param a com.nexirius.framework.LocaleListener
     * @param b com.nexirius.framework.LocaleListener
     * @return com.nexirius.framework.LocaleListener
     */
    public static LocaleListener add(LocaleListener a, LocaleListener b) {
        if (a == null)
            return b;
        if (b == null)
            return a;
        return new LocaleEventMulticaster(a, b);
    }

    /**
     * @param event com.nexirius.framework.LocaleEvent
     */
    public void localeChanged(LocaleEvent event) {
        ((LocaleListener) a).localeChanged(event);
        ((LocaleListener) b).localeChanged(event);
    }

    /**
     * Remove listener to support multicast events.
     *
     * @param a com.nexirius.framework.LocaleListener
     * @param b com.nexirius.framework.LocaleListener
     * @return com.nexirius.framework.LocaleListener
     */
    public static LocaleListener remove(LocaleListener a, LocaleListener b) {
        return (LocaleListener) removeInternal(a, b);
    }
}
