//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 *
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 *
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 *
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 *
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.util.simpletype;

import java.math.BigDecimal;

/**
 * @autor Marcel Baumann
 */
public class SimpleType_BigDecimal extends SimpleType {
    protected BigDecimal m_value;

    public SimpleType_BigDecimal(BigDecimal value) {
        m_value = value;
    }

    public SimpleType_BigDecimal(String value) throws Exception {
        set(value);
    }

    @Override
    public void set(String value) throws Exception {
        m_value = new BigDecimal(value);
    }

    public void set(BigDecimal value) {
        m_value = value;
    }

    @Override
    public SimpleType duplicate() {
        return new SimpleType_BigDecimal(m_value);
    }

    @Override
    public BigDecimal getBigDecimal() {
        return m_value;
    }

    @Override
    public boolean equals(Object other) {
        if (other != null && other instanceof SimpleType_BigDecimal) {
            if (((SimpleType_BigDecimal)other).m_value == null) {
                return m_value == null;
            }
            if (m_value == null) {
                return ((SimpleType_BigDecimal) other).m_value == null;
            }

            return ((SimpleType_BigDecimal) other).m_value.compareTo(m_value) == 0;
        }

        return false;
    }

    @Override
    public int compareTo(Object other)
    {
        if (other != null && other instanceof SimpleType_BigDecimal)
        {
            SimpleType_BigDecimal otherBigDecimal = (SimpleType_BigDecimal) other;
            if (otherBigDecimal.m_value == null)
            {
                return m_value == null ? 0 : 1;
            }

            return otherBigDecimal.m_value.compareTo(m_value);
        }

        return -1;
    }

    @Override
    public String toString() {
        return m_value.toString();
    }

    @Override
    public Object wrap() {
        return m_value;
    }

    @Override
    public int hashCode()
    {
        return(m_value == null ? 0 : m_value.hashCode());
    }
}
