//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.util.simpletype;

/**
 * @autor Marcel Baumann
 */
public class SimpleType_boolean extends SimpleType {



    protected boolean m_value;

    public SimpleType_boolean(boolean value) {
        m_value = value;
    }

    public SimpleType_boolean(String value)
            throws Exception {
        set(value);
    }

    public void set(String value)
            throws Exception {
        m_value = Boolean.valueOf(value).booleanValue();
    }

    public void set(boolean value) {
        m_value = value;
    }

    public SimpleType duplicate() {
        return new SimpleType_boolean(m_value);
    }

    public boolean getBoolean() {
        return m_value;
    }

    public boolean equals(Object other) {
        if (other != null && other instanceof SimpleType_boolean) {
            return ((SimpleType_boolean) other).m_value == m_value;
        }

        return false;
    }

    @Override
    public int compareTo(Object other)
    {
        if (other != null && other instanceof SimpleType_boolean) 
        {
            SimpleType_boolean otherBool = (SimpleType_boolean) other;
            if (m_value == otherBool.m_value)
            {
                // Identisch
                return(0);
                
            }
            // Ungleich!
            return (m_value ? 1 : -1);
        }

        return -1;
    }
    
    public String toString() {
        Boolean b = new Boolean(m_value);

        return b.toString();
    }

    public Object wrap() {
        return new Boolean(m_value);
    }
    
    @Override
    public int hashCode()
    {
        return(m_value ? -1 : 0);
    }

}
