//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.util.textresource;

/**
 * This is the event multicaster class to support the com.nexirius.framework.TextSourceListenerinterface.
 */
public class TextResourceEventMulticaster extends java.awt.AWTEventMulticaster
        implements TextResourceListener {




    /**
     * Constructor to support multicast events.
     *
     * @param a com.nexirius.framework.TextSourceListener
     * @param b com.nexirius.framework.TextSourceListener
     */
    protected TextResourceEventMulticaster(TextResourceListener a, TextResourceListener b) {
        super(a, b);
    }

    /**
     * Add new listener to support multicast events.
     *
     * @param a com.nexirius.framework.TextSourceListener
     * @param b com.nexirius.framework.TextSourceListener
     * @return com.nexirius.framework.TextSourceListener
     */
    public static TextResourceListener add(TextResourceListener a, TextResourceListener b) {
        if (a == null)
            return b;
        if (b == null)
            return a;
        return new TextResourceEventMulticaster(a, b);
    }

    /**
     * Remove listener to support multicast events.
     *
     * @param a com.nexirius.framework.TextSourceListener
     * @param b com.nexirius.framework.TextSourceListener
     * @return com.nexirius.framework.TextSourceListener
     */
    public static TextResourceListener remove(TextResourceListener a, TextResourceListener b) {
        return (TextResourceListener) removeInternal(a, b);
    }

    /**
     * @param event com.nexirius.framework.TextSourceEvent
     */
    public void textResourceChanged(TextResourceEvent event) {
        ((TextResourceListener) a).textResourceChanged(event);
        ((TextResourceListener) b).textResourceChanged(event);
    }
}
