//{HEADER
/**
 * This class is part of jnex 'Nexirius Application Framework for Java'
 *	
 * Copyright (C) Nexirius GmbH, CH-4450 Sissach, Switzerland (www.nexirius.ch)
 * 
 * <p>This library is free software; you can redistribute it and/or<br>
 * modify it under the terms of the GNU Lesser General Public<br>
 * License as published by the Free Software Foundation; either<br>
 * version 2.1 of the License, or (at your option) any later version.</p>
 * 
 * <p>This library is distributed in the hope that it will be useful,<br>
 * but WITHOUT ANY WARRANTY; without even the implied warranty of<br>
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU<br>
 * Lesser General Public License for more details.</p>
 * 
 * <p>You should have received a copy of the GNU Lesser General Public<br>
 * License along with this library; if not, write to the Free Software<br>
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</p>
 * </blockquote>
 * 
 * <p>
 * Nexirius GmbH, hereby disclaims all copyright interest in<br>
 * the library jnex' 'Nexirius Application Framework for Java' written<br>
 * by Marcel Baumann.</p>
 */
//}HEADER
package com.nexirius.util.unittest;

import java.awt.*;

/**
 * A basic extension of the java.awt.Frame class
 */
public class UnitTestFrame extends Frame implements java.awt.event.ActionListener {



    public UnitTestFrame() {
        // This code is automatically generated by Visual Cafe when you add
        // components to the visual environment. It instantiates and initializes
        // the components. To modify the code, only use code syntax that matches
        // what Visual Cafe can generate, or Visual Cafe may be unable to back
        // parse your Java file into its visual environment.
        //{{INIT_CONTROLS
        setLayout(null);
        setVisible(false);
        setSize(getInsets().left + getInsets().right + 923, getInsets().top + getInsets().bottom + 654);
        setBackground(new Color(12632256));
        m_unitsUnderTest = new java.awt.List(0, false);
        add(m_unitsUnderTest);
        m_unitsUnderTest.setBounds(getInsets().left + 132, getInsets().top + 12, 384, 204);
        m_unitsUnderTest.setEnabled(false);
        label1 = new java.awt.Label("Units to be tested:");
        label1.setBounds(getInsets().left + 12, getInsets().top + 12, 100, 24);
        add(label1);
        label2 = new java.awt.Label("Unit under test:");
        label2.setBounds(getInsets().left + 12, getInsets().top + 228, 100, 24);
        add(label2);
        m_currentlyUnderTest = new java.awt.TextField();
        m_currentlyUnderTest.setEditable(false);
        m_currentlyUnderTest.setBounds(getInsets().left + 132, getInsets().top + 228, 384, 24);
        m_currentlyUnderTest.setBackground(new Color(12632256));
        add(m_currentlyUnderTest);
        m_progress = new java.awt.TextArea();
        m_progress.setEditable(false);
        m_progress.setBounds(getInsets().left + 12, getInsets().top + 264, 900, 156);
        add(m_progress);
        m_closeButton = new java.awt.Button();
        m_closeButton.setActionCommand("button");
        m_closeButton.setLabel("Close");
        m_closeButton.setBounds(getInsets().left + 324, getInsets().top + 612, 84, 28);
        m_closeButton.setBackground(new Color(12632256));
        add(m_closeButton);
        m_closeButton.setEnabled(false);
        m_helpButton = new java.awt.Button();
        m_helpButton.setActionCommand("button");
        m_helpButton.setLabel("Help");
        m_helpButton.setBounds(getInsets().left + 516, getInsets().top + 612, 84, 28);
        m_helpButton.setBackground(new Color(12632256));
        add(m_helpButton);
        m_helpButton.setEnabled(false);
        label4 = new java.awt.Label("Test Messages");
        label4.setBounds(getInsets().left + 12, getInsets().top + 420, 100, 24);
        add(label4);
        m_testMessages = new java.awt.TextArea();
        m_testMessages.setEditable(false);
        m_testMessages.setBounds(getInsets().left + 12, getInsets().top + 444, 900, 156);
        add(m_testMessages);
        m_progressBar = new java.awt.Scrollbar(Scrollbar.HORIZONTAL);
        m_progressBar.setBounds(getInsets().left + 528, getInsets().top + 228, 384, 24);
        add(m_progressBar);
        m_progressBar.setEnabled(false);
        m_progressBar.setUnitIncrement(1);
        list1 = new java.awt.List(0, false);
        list1.setEnabled(false);
        add(list1);
        list1.setBounds(getInsets().left + 528, getInsets().top + 12, 384, 204);
        list1.setEnabled(false);
        setTitle("Unit Tester");
        //}}

        //{{INIT_MENUS
        //}}

        //{{REGISTER_LISTENERS
        SymWindow aSymWindow = new SymWindow();
        this.addWindowListener(aSymWindow);

        m_closeButton.addActionListener(this);
        m_unitsUnderTest.addActionListener(this);

        //}}
    }

    private long m_tickleTime = (new java.util.Date()).getTime() / 100;

    public void tickle() {
        long now = (new java.util.Date()).getTime() / 100;
        if (m_tickleTime < now) {
            m_tickleTime = now;

            if ((m_progressBar.getValue() + m_progressBar.getVisibleAmount()) >= m_progressBar.getMaximum())
                m_progressBar.setValue(m_progressBar.getMinimum());
            m_progressBar.setValue(m_progressBar.getValue() + 1);

        }
    }

    public void report(String msg) {
        list1.add(msg);
    }

    public UnitTestFrame(String title) {
        this();
        setTitle(title);
    }

    public void addClassToList(UnitTest c) {
        m_units.addElement(c);
        m_unitsUnderTest.add(c.getUnitTestName());
    }

    public void setCurrentUnit(UnitTest c) {
        m_currentUnitTest = c;

        m_progressBar.setVisible(false);

        // Loop through the stupid list and find the correct inde
        int i;
        for (i = 0; i < m_unitsUnderTest.getItemCount(); i++) {
            if (m_currentUnitTest.getUnitTestName().equals(m_unitsUnderTest.getItem(i))) {
                m_unitsUnderTest.makeVisible(i);
                m_unitsUnderTest.select(i);
                break;
            }
        }


        m_progress.setText(c.getProgress());
        m_currentlyUnderTest.setText(c.getUnitTestName());
        m_testMessages.setText(c.getTest());
    }

    public void reportFailure(String why) {
        results(why);
    }

    public void results(String res) {
        m_testMessages.append(res);
    }

    public void progress(String msg) {
        m_progress.append(msg);
    }

    public void passed(boolean b) {
        // Loop through the stupid list and find the correct inde
        int i;
        String s;
        String pf = b ? "passed : " : "FAILED : ";
        for (i = 0; i < m_unitsUnderTest.getItemCount(); i++) {
            if (m_currentUnitTest.getUnitTestName().equals((s = m_unitsUnderTest.getItem(i)))) {
                m_unitsUnderTest.replaceItem(pf + s, i);
                break;
            }
        }
    }

    public void enableExitButton(boolean b) {
        m_unitsUnderTest.setEnabled(b);
        m_closeButton.setEnabled(b);
    }

    public void actionPerformed(java.awt.event.ActionEvent ae) {
        Object o = ae.getSource();

        if (o == m_closeButton) {
            Runtime.getRuntime().runFinalization();
            Runtime.getRuntime().gc();
            Runtime.getRuntime().runFinalization();

            // List all the thread which are running...
            ThreadGroup tg = Thread.currentThread().getThreadGroup();
            ThreadGroup p = tg.getParent();
            while (p != null) {
                tg = p;
                p = tg.getParent();
            }
/*			
			System.out.println( "\n\nTopmost ThreadGroup : " + tg + " has " + tg.activeGroupCount() + " children." );
			Thread[] threads = new Thread[ 1000 ];
			int numThreads = tg.enumerate( threads, true );
			
			for ( int i = 0; i< numThreads; i++ )
			{
				System.out.println( "\n=======================================================" );
				String id = String.valueOf(i);
				Thread t = threads[i];
				
				System.out.print( "Thread[" + id + "] : " + t );
				if ( t.isDaemon() )
					System.out.print( " is Daemon " );
				else
					System.out.print( " " );
				
				System.out.print( "member of group  '" + t.getThreadGroup().getName() + "'  " );
				
				System.out.println( "" );				
				System.out.println( "" );
				
			}
			
*/
            Runtime.getRuntime().gc();
            Runtime.getRuntime().runFinalization();
            Runtime.getRuntime().gc();
            Runtime.getRuntime().runFinalization();

            System.exit(1);
        } else if (o == m_unitsUnderTest && m_closeButton.isEnabled()) {
            setCurrentUnit((UnitTest) m_units.elementAt(m_unitsUnderTest.getSelectedIndex()));
        }
    }

    public synchronized void show() {
        setLocation(50, 50) ;
        super.show();
    }

    public void addNotify() {
        // Record the size of the window prior to calling parents addNotify.
        Dimension d = getSize();

        super.addNotify();

        if (fComponentsAdjusted)
            return;

        // Adjust components according to the insets
        setSize(getInsets().left + getInsets().right + d.width, getInsets().top + getInsets().bottom + d.height);
        Component components[] = getComponents();
        for (int i = 0; i < components.length; i++) {
            Point p = components[i].getLocation();
            p.translate(getInsets().left, getInsets().top);
            components[i].setLocation(p);
        }
        fComponentsAdjusted = true;
    }

    // Used for addNotify check.
    boolean fComponentsAdjusted = false;

    java.util.Vector m_units = new java.util.Vector();
    UnitTest m_currentUnitTest;

    //{{DECLARE_CONTROLS
    java.awt.List m_unitsUnderTest;
    java.awt.Label label1;
    java.awt.Label label2;
    java.awt.TextField m_currentlyUnderTest;
    java.awt.TextArea m_progress;
    java.awt.Button m_closeButton;
    java.awt.Button m_helpButton;
    java.awt.Label label4;
    java.awt.TextArea m_testMessages;
    java.awt.Scrollbar m_progressBar;
    java.awt.List list1;
    //}}

    //{{DECLARE_MENUS
    //}}

    class SymWindow extends java.awt.event.WindowAdapter {
        public void windowClosing(java.awt.event.WindowEvent event) {
            Object object = event.getSource();
            if (object == UnitTestFrame.this)
                Frame1_WindowClosing(event);
        }
    }

    void Frame1_WindowClosing(java.awt.event.WindowEvent event) {
        hide();		 // hide the Frame
    }
}
